<template>
  <div>
    <v-data-table
      :loading="isLoading"
      :headers="headers"
      :items="data"
      height="350"
      class="elevation-1"
    >
      <template v-slot:top>
        <v-toolbar height="50" flat>
          <v-toolbar-title class="white--text">
            <v-dialog v-model="isDialogForm" max-width="500px">
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  fab
                  class="white--text"
                  color="primary"
                  small
                  right
                  absolute
                  v-bind="attrs"
                  v-on="on"
                >
                  <v-icon>mdi-plus</v-icon>
                </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <strong>{{ formTitle }}</strong>
                  <v-icon right color="orange">mdi-plus</v-icon>
                </v-card-title>
                <v-divider />
                <v-card-text>
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6" md="4">
                        <v-text-field
                          :disabled="editedIndex > -1"
                          v-model.trim="editedItem.nombre"
                          label="Nombre"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6" md="4">
                        <v-text-field
                          v-model.trim="editedItem.valor"
                          label="Valor"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6" md="4">
                        <v-select
                          v-model="editedItem.tipo"
                          :items="itemsType"
                          label="Tipo"
                        ></v-select>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-card-text>
                <v-divider />
                <v-card-actions>
                  <div style="width:100%" class="btnCenter">
                    <v-btn
                      class="ma-2"
                      dark
                      tile
                      depressed
                      color="secondary"
                      @click="close"
                      >No, cancelar</v-btn
                    >
                    <v-btn
                      :class="[
                        { desac: !editedItem.nombre },
                        { desac: !editedItem.valor },
                      ]"
                      class="ma-2"
                      depressed
                      dark
                      tile
                      color="primary"
                      @click="save"
                      >Si, continuar</v-btn
                    >
                  </div>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-toolbar-title>
        </v-toolbar>
      </template>
      <template v-slot:item.actions="{ item }">
        <v-icon small class="mr-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon small @click="deleteItem(item)">
          mdi-delete
        </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="getPropiedades">
          Reintentar
        </v-btn>
      </template>
    </v-data-table>
    <template>
      <v-dialog v-model="isDialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh...! </strong>
            Borrar propiedad. Estas totalmente seguro?
            <v-icon right color="orange">mdi-alert</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p v-if="editedItem.nombre">
              Para confirmar esta acción por favor escribe:
              <br />
              <em
                ><code>{{ editedItem.nombre }}</code></em
              >
            </p>
            <v-text-field
              v-model="confirmText"
              :autofocus="true"
              label="Confirma con el nombre de la vista"
              flat
              class="mr-2 ml-2"
            />
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="closeDelete"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  {
                    desac: !(
                      editedItem.nombre && confirmText == editedItem.nombre
                    ),
                  },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteItemConfirm"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="isDialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh...! </strong>
            Todo todo ha salio bien
            <v-icon right color="green">mdi-check-circle-outline</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡Tus datos fueron guardados!
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="isDialogSave = false"
                >Entiendo</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Propiedades",
  props: ["vistaIn"],
  data: () => ({
    isLoading: false,
    isDialogSave: false,
    isDialogDelete: false,
    isDialogForm: false,
    confirmText: null,
    headers: [
      { text: "Nombre", value: "nombre" },
      { text: "Valor", value: "valor" },
      { text: "Tipo", value: "tipo" },
      { text: "Acciones", value: "actions", sortable: false },
    ],
    data: [],
    itemsType: ["String", "List", "Number"],
    editedIndex: -1,
    editedItem: {
      nombre: "",
      valor: null,
      tipo: "String",
    },
    defaultItem: {
      nombre: "",
      valor: null,
      tipo: "String",
    },
  }),
  computed: {
    formTitle() {
      return this.editedIndex === -1 ? "Nueva" : "Edición";
    },
  },
  watch: {
    isDialogForm(val) {
      val || this.close();
    },
    isDialogDelete(val) {
      val || this.closeDelete();
    },
  },
  methods: {
    getPropiedades() {
      this.isLoading = true;
      axios(
        "/accesos/sistema/vistas/v1/" +
          this.vistaIn.data.idVista +
          "/propiedades"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = data.resultado.propiedades;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.isLoading = false;
        });
    },
    postPropiedad() {
      let body = {
        ...this.editedItem,
      };
      axios
        .post(
          "/accesos/sistema/vistas/v1/" +
            this.vistaIn.data.idVista +
            "/propiedades",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.editedItem.idPropiedad = data.resultado.id;
            this.data.push(this.editedItem);
            this.close();
            this.isDialogSave = true;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    putPropiedad() {
      let body = {
        ...this.editedItem,
      };
      delete body.idPropiedad;
      axios
        .put(
          "/accesos/sistema/vistas/v1/" +
            this.vistaIn.data.idVista +
            "/propiedades",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            Object.assign(this.data[this.editedIndex], this.editedItem);
            this.isDialogSave = true;
            this.close();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deletePropiedad() {
      axios
        .delete(
          "/accesos/sistema/vistas/v1/" +
            this.vistaIn.data.idVista +
            "/propiedades/" +
            this.editedItem.idPropiedad
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data.splice(this.editedIndex, 1);
            this.closeDelete();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    editItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.isDialogForm = true;
    },
    deleteItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.isDialogDelete = true;
    },
    deleteItemConfirm() {
      this.deletePropiedad();
    },
    close() {
      this.isDialogForm = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },
    closeDelete() {
      this.isDialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },
    save() {
      if (this.editedIndex > -1) {
        this.putPropiedad();
      } else {
        this.postPropiedad();
      }
    },
  },
  created() {
    this.getPropiedades();
  },
};
</script>
